#!/bin/bash

UA="Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/91.0.4479.106 Safari/537.36"
APIsrv="https://data-api.wp.pl/graphql"

replyJSON=$(curl -s -A "$UA" --header "Content-Type: application/json" --request POST --data '{"operationName":"getPublicationItems","variables":{"offset":0,"types":["ARTICLE"],"productIds":["6504404458915457"],"first":10,"excludeIds":[],"excludeTagIds":["6004707301569153","6627237933787265"]},"query":"query getPublicationItems($productIds: [String!], $first: Int!, $offset: Int = 0, $tagName: String, $excludeIds: [String!], $excludeTagIds: [String!], $types: [RecordType!] = [ARTICLE]) {\n  collections(productIds: $productIds) {\n    records(\n      first: $first\n      offset: $offset\n      types: $types\n      tagName: $tagName\n      excludeIds: $excludeIds\n      excludeTagIds: $excludeTagIds\n    ) {\n      ...PublicationListingFragment\n      }\n  }\n}\n\nfragment PublicationListingFragment on CollectionRecordsConnection {\n  edges {\n    node {\n      id\n      name\n      }\n  }\n }\n\n"}' $APIsrv)



idArr=($(echo $replyJSON | jq -r '.data.collections.records.edges[].node | .id'))
#mapfile -t topicArr <<< $(echo $replyJSON | jq -r '.data.collections.records.edges[].node | .name')
topicb64Arr=($(echo $replyJSON | jq -r '.data.collections.records.edges[].node | .name | @base64')) #kodowanie do base64, aby zapobiec niepożądanym znakom w tematach

tmaxindex=$((${#topicb64Arr[@]}-1))

for (( i=0; i<=$tmaxindex; i++ ))
do

useridJSON=$(curl -s -A "$UA" --header "Content-Type: application/json" --request POST --data '{"operationName":"getComments","variables":{"productId":"6504404458915457","contentId":"'${idArr[$i]}'","first":50,"sort":"LATEST","parentId":null},"query":"query getComments($productId: String!, $first: Int!, $contentId: String!, $sort: CommentsSortType!, $after: String, $parentId: String) {\n  comments(productId: $productId, first: $first, sort: $sort, contentId: $contentId, after: $after, parentId: $parentId) {\n    edges {\n      node {\n        id\n        nick\n      }\n        }\n  }\n}\n"}' $APIsrv)


#wydobycie parentId, dla konkretnego nicka w danym temacie
nickcID=($(echo $useridJSON | jq -r '.data.comments.edges[].node | select(.nick=="'$1'") | .id'))

    if [[ ! -z $nickcID ]]; then
        topicChckArr+=($i) #tablica z indexami tematów do sprawdzenia
        nickcIDArr+=($nickcID)
    fi

done
unset i

if [[ ${#nickcIDArr[@]} -eq 0 ]]; then 
echo "Użytkownik o nicku $1 nie komentował ostatnich ${#idArr[@]} tematów!" && exit 0
fi

nmaxindex=$((${#nickcIDArr[@]}-1))

for (( i=0; i<=$nmaxindex; i++ ))
do

cID=${idArr[${topicChckArr[$i]}]}
pID=${nickcIDArr[$i]}

commReplyJSON=$(curl -s -A "$UA" --header "Content-Type: application/json" --request POST --data '{"operationName":"getComments","variables":{"productId":"6504404458915457","contentId":"'$cID'","first":10,"sort":"CHRONOLOGIC","parentId":"'$pID'"},"query":"query getComments($productId: String!, $first: Int!, $contentId: String!, $sort: CommentsSortType!, $after: String, $parentId: String) {\n  comments(\n    productId: $productId\n    first: $first\n    sort: $sort\n    contentId: $contentId\n    after: $after\n    parentId: $parentId\n  ) {\n    edges {\n      node {\n        id\n        text\n        created\n        nick\n        votesUp\n        votesDown\n        replies\n        user {\n          id\n          avatar\n          username\n          label\n          authorId\n          __typename\n        }\n        __typename\n      }\n      __typename\n    }\n    pageInfo {\n      hasNextPage\n      endCursor\n      __typename\n    }\n    __typename\n  }\n}\n"}' $APIsrv)

echo -e "\nARTYKUŁ: \"$(echo ${topicb64Arr[${topicChckArr[$i]}]} | base64 -d)\""
echo "ODPOWIEDZI DLA \"$1\":"
echo "$commReplyJSON" | jq -C '.data.comments.edges[].node | { created:(.created|todate), nick, text, votesUp, votesDown }'

echo -e "Ilość odpowiedzi: "
echo "$commReplyJSON" | jq '.data.comments.edges[].node.id | length' | wc -l
echo -e "\n"

done
